package com.zg.project.wisdom.mapper;

import java.util.List;
import com.zg.project.wisdom.domain.RkInfo;
import org.apache.ibatis.annotations.Param;

/**
 * 库存单据主Mapper接口
 * 
 * @author zg
 * @date 2025-05-28
 */
public interface RkInfoMapper 
{
    /**
     * 查询库存单据主
     * 
     * @param id 库存单据主主键
     * @return 库存单据主
     */
    public RkInfo selectRkInfoById(Long id);

    /**
     * 查询库存单据主列表
     * 
     * @param rkInfo 库存单据主
     * @return 库存单据主集合
     */
    public List<RkInfo> selectRkInfoList(RkInfo rkInfo);


    /**
     * 修改库存单据主
     * 
     * @param rkInfo 库存单据主
     * @return 结果
     */
    public int updateRkInfo(RkInfo rkInfo);

    /**
     * 删除库存单据主
     * 
     * @param id 库存单据主主键
     * @return 结果
     */
    public int deleteRkInfoById(Long id);

    /**
     * 批量删除库存单据主
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRkInfoByIds(Long[] ids);

    /**
     * 新增入库单据
     * @param saveList
     * @return
     */
    int batchInsertRkInfo(List<RkInfo> saveList);

    /**
     * 根据库位编码查询入库单据
     * @param locationCode
     * @return
     */
    int countRkInfoByLocationCode(@Param("locationCode") String locationCode);

    /**
     * 查询已使用库位
     * @return
     */
    List<String> selectUsedPcodes();

    /**
     * 根据单据编号查询SAP单号
     * @param billNo
     * @return
     */
    List<String> selectSapNoByBillNo(String billNo);

    /**
     * 根据单据编号删除入库单据
     * @param billNo
     */
    void deleteByBillNo(String billNo);


    /**
     * 统计超期库存
     * @return
     */
    int countOverdueStock();

    /**
     * 获取最新20条逾期库存列表
     * @param
     * @return
     */
    List<RkInfo> selectTopOverdueStock(@Param("limit") int limit);

    /**
     * 批量更新出库信息
     * @param list
     * @return
     */
    int batchUpdateOutStock(List<RkInfo> list);
}
